#include <cmath>
#include <string>
#include <cstdlib>

#include "CString.h"

string::string()
{
	cells[0] = NULLC;
}

string::operator char*()
{
	return (cells);
}

string::string(char arg[])
{
	std::strncpy (cells, arg, (MAX - 1));
}

string string::operator = (string a)
{
	std::strcpy (cells, a.cells);
	return (*this);
}

int string::Atoi()
{
	return (std::atoi (cells));
}

float string::Atof()
{
	return static_cast<float>(std::atof (cells));
}

int string::length()
{
	return static_cast<int>(std::strlen (cells));
}

void string::inputStr (std::istream& in)
{
	in >> cells;
}

void string::outputStr (std::ostream& out)
{
	out << cells;
}

int string::operator == (string a)
{
	return (!std::strcmp (cells, a.cells));
}

int string::operator != (string a)
{
	return (std::strcmp (cells, a.cells));
}

int string::operator < (string a)
{
	if (std::strcmp (cells, a.cells) < 0)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

int string::operator > (string a)
{
	if (std::strcmp (cells, a.cells) > 0)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

int string::operator <= (string a)
{
	if (std::strcmp (cells, a.cells) <= 0)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

int string::operator >= (string a)
{
	if (std::strcmp (cells, a.cells) >= 0)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

string string::subStr (int n, int size)
{
	string temp;

	if (n < (MAX - 1))
	{
		std::strncpy (temp.cells, (cells + n), size);
		temp.cells[size] = NULLC;
	}

	return (temp);
}int string::contains (string a)
{
	char *ptr;
	ptr = std::strstr (cells, a.cells);

	if (ptr == NULL)
	{
		return -1;
	}
	else
	{
		return (int)(ptr - cells);
	}
}

string string::operator + (string s)
{
	int n;
	string temp;
	std::strcpy (temp.cells, cells);
	n = std::strlen (cells);

	if ((MAX - n - 1) > 0)
	{
		std::strncpy ((temp.cells + n), s.cells, (MAX - n - 1));
		return (temp);
	}
}

char string::oneChar (int n)
{
	if (n < std::strlen (cells))
	{
		return (cells[n]);
	}
	else
	{
		return -1;
	}
}

void string::oneChar (int n, char c)
{
	if (n < std::strlen (cells))
	{
		cells[n] = c;
	}
}

std::istream& operator >> (std::istream& in, string& a)
{
	a.inputStr(in);
	return (in);
}

std::ostream& operator << (std::ostream& out, string& a)
{
	a.outputStr(out);
	return (out);
}