#pragma once
#include <iostream>
#include <fstream>
#include "menu.h"
#include "vector.h"

////////////////////////////////////////////////////////////////////////////////////
menu::menu()
{
	menuItem = ' ';
	volumeScalar.x = 2;
	volumeScalar.y = 2;
	volumeScalar.z = 2;
	pColorMap = "";
	pOpacityMap = "";
	pHeightMap = "";
	pScaleMap = "";
	pOpacityConstant = 255.0;
	pVelocityConstant = 1.0;
	pVelocityMinConstant = 1.0;
	pVelocityMaxConstant = 1.0;
	pHeightMaxConstant = 0.0;
	pScaleConstant = 1.0;
}

menu::~menu()
{
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getpColorMap()
{
	return pColorMap;
}

void menu::setpColorMap(std::string pColorMap)
{
	pColorMap = pColorMap;
}

////////////////////////////////////////////////////////////////////////////////////
vector menu::getVolumeScalar()
{
	return volumeScalar;
}

void menu::setVolumeScalar(vector scatterVolumeScalar)
{
	scatterVolumeScalar.x = static_cast <float>(static_cast <int> (scatterVolumeScalar.x));
	scatterVolumeScalar.y = static_cast <float>(static_cast <int> (scatterVolumeScalar.y));
	scatterVolumeScalar.z = static_cast <float>(static_cast <int> (scatterVolumeScalar.z));

	if (scatterVolumeScalar.x < 2)
	{
		std::cout << "Scatter volume scalar X lower than 2. Value modified to 2." << std::endl;
		scatterVolumeScalar.x = 2.0f;
	}
	if (scatterVolumeScalar.x > 20)
	{
		std::cout << "Scatter volume scalar X higher than 20. Value modified to 20." << std::endl;
		scatterVolumeScalar.x = 20.0f;
	}

	if (scatterVolumeScalar.y < 2)
	{
		std::cout << "Scatter volume scalar Y lower than 2. Value modified to 2." << std::endl;
		scatterVolumeScalar.y = 2.0f;
	}
	if (scatterVolumeScalar.y > 20)
	{
		std::cout << "Scatter volume scalar Y higher than 20. Value modified to 20." << std::endl;
		scatterVolumeScalar.y = 20.0f;
	}

	if (scatterVolumeScalar.z < 2)
	{
		std::cout << "Scatter volume scalar Z lower than 2. Value modified to 2." << std::endl;
		scatterVolumeScalar.z = 2.0f;
	}
	if (scatterVolumeScalar.z > 20)
	{
		std::cout << "Scatter volume scalar Z higher than 20. Value modified to 20." << std::endl;
		scatterVolumeScalar.z = 20.0f;
	}

	volumeScalar = scatterVolumeScalar;
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getpOpacityMap()
{
	return pOpacityMap;
}

float menu::getpOpacityConstant()
{
	return pOpacityConstant;
}

void menu::setpOpacityMap(std::string pOpacityMap)
{
	pOpacityMap = pOpacityMap;
}

void menu::setpOpacityConstant(float &pOpacityConstant)
{
	if (pOpacityConstant < 1)
	{
		pOpacityConstant = 1;
		std::cout << "Pixel opacity constant lower than 1. Value modified to 1." << std::endl;
	}
	if (pOpacityConstant > 255)
	{
		pOpacityConstant = 255;
		std::cout << "Pixel opacity constant higher than 255. Value modified to 255." << std::endl;
	}
	pOpacityConstant = static_cast <float> (static_cast <int> (pOpacityConstant));
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getpVelocityMap()
{
	return pVelocityMap;
}

double menu::getpVelocityConstant()
{
	return pVelocityConstant;
}

double menu::getpVelocityMinConstant()
{
	return pVelocityMinConstant;
}

double menu::getpVelocityMaxConstant()
{
	return pVelocityMaxConstant;
}

void menu::setpVelocityMap(std::string pVelocityMap)
{
	pVelocityMap = pVelocityMap;
}

void menu::setpVelocityConstant(double &pVelocityConstant)
{
	if (pVelocityConstant < 0.01)
	{
		pVelocityConstant = 0.1;
		std::cout << "Pixel velocity scalar constant lower than 0.01. Value modified to 0.01." << std::endl;
	}
	if (pVelocityConstant > 20)
	{
		pVelocityConstant = 20;
		std::cout << "Pixel velocity scalar constant higher than 20. Value modified to 20." << std::endl;
	}
	pVelocityConstant = pVelocityConstant;
}

void menu::setpVelocityMinConstant(double pVelocityMinConstant)
{
	if (pVelocityMinConstant < 0.01)
	{
		pVelocityMinConstant = 0.01;
		std::cout << "Pixel velocity scalar constant MIN lower than 0.01. Value modified to 0.01." << std::endl;
	}
	if (pVelocityMinConstant > 20)
	{
		pVelocityMinConstant = 20;
		std::cout << "Pixel velocity scalar constant MIN higher than 20. Value modified to 20." << std::endl;
	}
	pVelocityMinConstant = pVelocityMinConstant;
}

void menu::setpVelocityMaxConstant(double pVelocityMaxConst)
{
	if (pVelocityMaxConst < 0.01)
	{
		pVelocityMaxConst = 0.01;
		std::cout << "Pixel velocity scalar constant MAX lower than 0.01. Value modified to 0.01." << std::endl;
	}
	if (pVelocityMaxConst > 20)
	{
		pVelocityMaxConst = 20;
		std::cout << "Pixel velocity scalar constant MAX higher than 20. Value modified to 20." << std::endl;
	}

	if (pVelocityMaxConst < pVelocityMinConstant)
	{
		std::cout << "Pixel velocity scalar constant MAX lower than MIN. Values of MIN & MAX switched." << std::endl;
		double temp = pVelocityMaxConst;
		pVelocityMaxConst = pVelocityMinConstant;
		pVelocityMinConstant = temp;
	}
	pVelocityMaxConstant = pVelocityMaxConst;
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getpHeightMap()
{
	return pHeightMap;
}

float menu::getpHeightMaxConstant()
{
	return pHeightMaxConstant;
}

void menu::setpHeightMap(std::string pHeightMap)
{
	pHeightMap = pHeightMap;
}

void menu::setpHeightMaxConstant(float &pHeightMaxConstant)
{
	if (pHeightMaxConstant < 0)
	{
		pHeightMaxConstant = 0;
		std::cout << "Height offset constant MAX lower than 0. Value modified to 0." << std::endl;
	}
	if (pHeightMaxConstant > 50)
	{
		pHeightMaxConstant = 50;
		std::cout << "Height offset constant MAX higher than 50. Value modified to 50." << std::endl;
	}
	pHeightMaxConstant = static_cast <float> (static_cast <int> (pHeightMaxConstant));
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getpScaleMap()
{
	return pScaleMap;
}

float menu::getpScaleConstant()
{
	return pScaleConstant;
}

void menu::setpScaleMap(std::string pScaleMap)
{
	pScaleMap = pScaleMap;
}

void menu::setpScaleConstant(float &pScaleConstant)
{
	if (pScaleConstant < 0)
	{
		pScaleConstant = 0;
		std::cout << "Pixel scalar constant lower than 0.1. Value modified to 0." << std::endl;
	}
	if (pScaleConstant > 20)
	{
		pScaleConstant = 20;
		std::cout << "Pixel scalar constant higher than 20. Value modified to 20." << std::endl;
	}
	pScaleConstant = static_cast <float> (pScaleConstant);
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMainMenu()
{
	menuItem = ' ';
	std::cout << "A. Define essential attributes" << std::endl;
	std::cout << "B. Define miscellaneous attributes" << std::endl;
	std::cout << "C. View attributes" << std::endl;
	std::cout << "D. Do the number crunching" << std::endl;
	std::cout << "X. Exit PPC-cruncher" << std::endl;
	std::cout << std::endl;
	std::cout << "Menu item:";
	std::cin >> menuItem;
	std::cout << std::endl;

	switch(menuItem)
	{
		case 'a':
		case 'A':
			showMenuItem1();
			break;

		case 'b':
		case 'B':
			showMenuItem2();
			break;

		case 'c':
		case 'C':
			showMenuItem3();
			break;

		case 'd':
		case 'D':
			showMenuItem4();
			break;

		case 'x':
		case 'X':
			showMenuItem5();
			break;

		default:
			showErrorMessage();
			break;
	}
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem1()
{
	menuItem = ' ';
	std::cout << "A. Define color map" << std::endl;
	std::cout << "B. Define pixel scatter volume scalar" << std::endl;
	std::cout << "X. Show main menu" << std::endl;
	std::cout << std::endl;
	std::cout << "Menu item:";
	std::cin >> menuItem;
	std::cout << std::endl;

	switch(menuItem)
	{
		case 'a':
		case 'A':
			showMenuItem11();
			break;

		case 'b':
		case 'B':
			showMenuItem12();
			break;

		case 'x':
		case 'X':
			showMainMenu();
			break;

		default:
			showErrorMessage();
			break;
	}
}

void menu::showMenuItem11()
{
	menuItem = ' ';
	std::cout << "Color map:";
	std::cin >> pColorMap;

	setpColorMap(pColorMap);
	std::cout << std::endl;
	showMenuItem1();
}

void menu::showMenuItem12()
{
	menuItem = ' ';
	vector vScalar;
	std::cout << "Scatter volume scalar X:";
	std::cin >> vScalar.x;
	std::cout << "Scatter volume scalar Y:";
	std::cin >> vScalar.y;
	std::cout << "Scatter volume scalar Z:";
	std::cin >> vScalar.z;

	setVolumeScalar(vScalar);
	std::cout << std::endl;
	showMenuItem1();
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem2()
{
	menuItem = ' ';
	std::cout << "A. Define opacity map" << std::endl;
	std::cout << "B. Define opacity constant" << std::endl;
	std::cout << "C. Define velocity scalar map" << std::endl;
	std::cout << "D. Define velocity scalar constant" << std::endl;
	std::cout << "E. Define pixel scalar map" << std::endl;
	std::cout << "F. Define pixel scalar constant" << std::endl;
	std::cout << "G. Define height displacement map" << std::endl;
	std::cout << "X. Show main menu" << std::endl;
	std::cout << std::endl;
	std::cout << "Menu item:";
	std::cin >> menuItem;
	std::cout << std::endl;

	switch(menuItem)
	{
		case 'a':
		case 'A':
			showMenuItem21();
			break;

		case 'b':
		case 'B':
			showMenuItem22();
			break;

		case 'c':
		case 'C':
			showMenuItem23();
			break;

		case 'd':
		case 'D':
			showMenuItem24();
			break;

		case 'e':
		case 'E':
			showMenuItem25();
			break;

		case 'f':
		case 'F':
			showMenuItem26();
			break;

		case 'g':
		case 'G':
			showMenuItem27();
			break;

		case 'x':
		case 'X':
			showMainMenu();
			break;

		default:
			showErrorMessage();
			break;
	}
}

void menu::showMenuItem21()
{
	std::cout << "Opacity map:";
	std::cin >> pOpacityMap;

	setpOpacityMap(pOpacityMap);
	std::cout << std::endl;

	showMenuItem2();
}

void menu::showMenuItem22()
{
	std::cout << "Opacity constant:";
	std::cin >> pOpacityConstant;

	pOpacityConstant = static_cast <float> (static_cast <int> (pOpacityConstant));
	setpOpacityConstant(pOpacityConstant);
	std::cout << std::endl;

	showMenuItem2();
}

void menu::showMenuItem23()
{
	std::cout << "Velocity scalar map:";
	std::cin >> pVelocityMap;
	setpVelocityMap(pVelocityMap);

	std::cout << "Velocity scalar MIN:";
	std::cin >> pVelocityMinConstant;

	std::cout << "Velocity scalar MAX:";
	std::cin >> pVelocityMaxConstant;

	setpVelocityMinConstant(pVelocityMinConstant);
	setpVelocityMaxConstant(pVelocityMaxConstant);
	std::cout << std::endl;

	showMenuItem2();
}

void menu::showMenuItem24()
{
	std::cout << "Velocity scalar constant:";
	std::cin >> pVelocityConstant;

	setpVelocityConstant(pVelocityConstant);
	std::cout << std::endl;

	showMenuItem2();
}

void menu::showMenuItem25()
{
	std::cout << "Pixel scalar map:";
	std::cin >> pScaleMap;

	setpScaleMap(pScaleMap);
	std::cout << std::endl;

	showMenuItem2();
}

void menu::showMenuItem26()
{
	std::cout << "Pixel scalar constant:";
	std::cin >> pScaleConstant;

	setpScaleConstant(pScaleConstant);
	std::cout << std::endl;

	showMenuItem2();
}

void menu::showMenuItem27()
{
	std::cout << "Height map:";
	std::cin >> pHeightMap;
	std::cout << "Height map MAX:";
	std::cin >> pHeightMaxConstant;

	pHeightMaxConstant = static_cast <float> (static_cast <int> (pHeightMaxConstant));
	setpHeightMap (pHeightMap);
	setpHeightMaxConstant(pHeightMaxConstant);
	std::cout << std::endl;

	showMenuItem2();
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem3()
{
	menuItem = ' ';
	std::cout <<"----------------------------------------" << std::endl;

	//////////////////////////
	if (pColorMap.size() == 0)
	{
		std::cout << "pColorMap:\t\t" << "Undefined" << std::endl;
	}
	else
	{
		std::cout << "pColorMap:\t\t" << pColorMap << std::endl;
	}
	std::cout << std::endl;

	std::cout << "Scatter volume scalar:\t" << volumeScalar << std::endl;
	std::cout << std::endl;

	//////////////////////////
	if (pOpacityMap.size() == 0)
	{
		std::cout << "pOpacityMap:\t\t" << "Undefined" << std::endl;
	}
	else
	{
		std::cout << "pOpacityMap:\t\t" << pOpacityMap << std::endl;
		std::cout << "pOpacityConstant:\t" << getpOpacityConstant() << std::endl;
	}
	std::cout << std::endl;

	//////////////////////////
	if (pVelocityMap.size() == 0)
	{
		std::cout << "pVelocityMap:\t\t" << "Undefined" << std::endl;
		std::cout << "pVelocityConstant:\t" << getpVelocityConstant() << std::endl;
	}
	else
	{
		std::cout << "pVelocityMap:\t\t" << pVelocityMap << std::endl;
		std::cout << "pVelocityMinConstant:\t" << getpVelocityMinConstant() << std::endl;
		std::cout << "pVelocityMaxConstant:\t" << getpVelocityMaxConstant() << std::endl;
	}

	std::cout << std::endl;

	//////////////////////////
	if (pHeightMap.size() == 0)
	{
		std::cout << "pHeightMap:\t\t" << "Undefined" << std::endl;
	}
	else
	{
		std::cout << "pHeightMap:\t\t" << pHeightMap << std::endl;
		std::cout << "pHeightMaxConstant:\t" << getpHeightMaxConstant() << std::endl;
	}

	std::cout << std::endl;

	//////////////////////////
	if (pScaleMap.size() == 0)
	{
		std::cout << "pScaleMap:\t\t" << "Undefined" << std::endl;
	}
	else
	{
		std::cout << "pScaleMap:\t\t" << pScaleMap << std::endl;
		std::cout << "pScaleConstant:\t\t" << getpScaleConstant() << std::endl;
	}

	std::cout <<"----------------------------------------" << std::endl;
	std::cout << std::endl;
	showMainMenu();
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem4()
{
	menuItem = ' ';
	std::cout << "Are you sure? (Y / N)" << std::endl;
	std::cout << std::endl;
	std::cout << "Menu item:";
	std::cin >> menuItem;
	std::cout << std::endl;

	switch(menuItem)
	{
		case 'y':
		case 'Y':
			break;

		case 'n':
		case 'N':
			showMainMenu();
			break;

		default:
			showErrorMessage();
			break;
	}
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem5()
{
	menuItem = ' ';
	std::cout << "Sure you want to quit? (Y / N)" << std::endl;
	std::cout << std::endl;
	std::cout << "Menu item:";
	std::cin >> menuItem;
	std::cout << std::endl;

	switch(menuItem)
	{
		case 'y':
		case 'Y':
			exit(0);
			break;

		case 'n':
		case 'N':
			showMainMenu();
			break;

		default:
			showErrorMessage();
			break;
	}
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showErrorMessage()
{
	menuItem = ' ';
	std::cout << std::endl;
	std::cout << "Menu-item not defined." << std::endl;
	std::cout << std::endl;
	showMainMenu();
}