#pragma once
#include "pixel.h"

////////////////////////////////////////////////////////////////////////////////////
pixel::pixel()
{
	pixelScale = 1.0;
	velocityScalar = 1.0;
	finalPosition = true;
}

// Destructor isn't necessary as there is no data that won't be released
// by deleting the object. (there aren't any pointers in the object) (btw, arrays are pointers)
//pixel::~pixel()
//{
//
//}

////////////////////////////////////////////////////////////////////////////////////
// Return the current position as a vector object. No sweat.
vector pixel::getCurrentPosition()
{
	return currentPos;
}

void pixel::setCurrentPosition(float const &x, float const &y, float const &z)
{
	currentPos.x = x;
	currentPos.y = y;
	currentPos.z = z;
}

void pixel::setCurrentPosition(vector const &v)
{
	currentPos = v;
}

////////////////////////////////////////////////////////////////////////////////////
vector pixel::getNextPosition()
{
	return nextPos;
}

void pixel::setNextPosition(float const &x, float const &y, float const &z)
{
	nextPos.x = x;
	nextPos.y = y;
	nextPos.z = z;
}

void pixel::setNextPosition(vector const &v)
{
	nextPos = v;
}

////////////////////////////////////////////////////////////////////////////////////
vector pixel::getFinalPosition()
{
	return finalPos;
}

void pixel::setFinalPosition(float const &x, float const &y, float const &z)
{
	finalPos.x = x;
	finalPos.y = y;
	finalPos.z = z;
}

void pixel::setFinalPosition(vector const &v)
{
	finalPos = v;
}

////////////////////////////////////////////////////////////////////////////////////
vector pixel::getPositionDifference()
{
	vector vTemp;
	vTemp.x = (pixel::getCurrentPosition().x - pixel::getFinalPosition().x);
	if (vTemp.x < 0)
	{
		vTemp.x = (vTemp.x * -1);
	}

	vTemp.y = (pixel::getCurrentPosition().y - pixel::getFinalPosition().y);
	if (vTemp.y < 0)
	{
		vTemp.y = (vTemp.y * -1);
	}
	vTemp.z = (pixel::getCurrentPosition().z - pixel::getFinalPosition().z);
	if (vTemp.z < 0)
	{
		vTemp.z = (vTemp.z * -1);
	}

	return vTemp;
}

////////////////////////////////////////////////////////////////////////////////////
vector pixel::getVelocity()
{
	return velocity;
}

void pixel::setVelocity(float const &x, float const &y, float const &z)
{
	velocity.x = x;
	velocity.y = y;
	velocity.z = z;
}

void pixel::setVelocity(vector const &v)
{
	velocity = v;
}

////////////////////////////////////////////////////////////////////////////////////
void pixel::setVelocityScalar(float &s)
{
	velocityScalar = s;
}

float pixel::getVelocityScalar()
{
	return velocityScalar;
}

////////////////////////////////////////////////////////////////////////////////////
float pixel::getPixelScale()
{
	return pixelScale;
}

void pixel::setPixelScale(float const &scale)
{
	pixelScale = scale;
}

////////////////////////////////////////////////////////////////////////////////////
bool pixel::checkPosition()
{
	if (pixel::getFinalPosition() == pixel::getCurrentPosition())
	{
		finalPosition = true;
	}
	else
	{
		finalPosition = false;
	}
	return finalPosition;
}