#pragma once
#include "vector.h"
#include <iostream>

// Default constructor
vector::vector()
{
	x = 0;
	y = 0;
	z = 0;
}

vector::vector(float const &x, float const &y, float const &z)
{
	this->x = x;
	this->y = y;
	this->z = z;
}

std::istream& operator >> (std::istream &is, vector &v)
{
	is >> v.x >> v.y >> v.z;
	return is;
}

std::ostream& operator << (std::ostream &os, vector &v)
{
	os << "<<"<< v.x << ", " << v.y << ", " << v.z << ">>";
	return os;
}

////////////////////////////////////////////////////////////////////////////////////
const vector &vector::operator = (const vector &v) 
{
	this->x = v.x;
	this->y = v.y;
	this->z = v.z;
	return *this;			
}

bool vector::operator == (const vector &v) const
{
	if (this->x == v.x && this->y == v.y && this->z == v.z)
	{
		return true;
	}
	else
	{
		return false;
	}	
}

bool vector::operator != (const vector &v) const
{
	if (this->x != v.x || this->y != v.y || this->z != v.z)
	{
		return true;
	}
	else
	{
		return false;
	}	
}

////////////////////////////////////////////////////////////////////////////////////
vector vector::operator + (const vector &v) const
{
	vector vTemp;
	vTemp.x = this->x + v.x;
	vTemp.y = this->y + v.y;
	vTemp.z = this->z + v.z;
	return vTemp;			
}

const vector &vector::operator += (const vector &v) 
{
	this->x = this->x + v.x;
	this->y = this->y + v.y;
	this->z = this->z + v.z;
	return *this;			
}

////////////////////////////////////////////////////////////////////////////////////
vector vector::operator - (const vector &v) const
{
	vector vTemp;
	vTemp.x = this->x - v.x;
	vTemp.y = this->y - v.y;
	vTemp.z = this->z - v.z;
	return vTemp;			
}

const vector &vector::operator -= (const vector &v) 
{
	this->x = this->x - v.x;
	this->y = this->y - v.y;
	this->z = this->z - v.z;
	return *this;			
}

////////////////////////////////////////////////////////////////////////////////////
vector vector::operator * (const float &s) const
{
	vector vTemp;
	vTemp.x = this->x * s;
	vTemp.y = this->y * s;
	vTemp.z = this->z * s;
	return vTemp;			
}

const vector &vector::operator *= (const float &s) 
{
	vector vTemp;
	this->x = this->x * s;
	this->y = this->y * s;
	this->z = this->z * s;
	return *this;			
}

////////////////////////////////////////////////////////////////////////////////////
vector vector::operator / (const float &s) const
{
	vector vTemp;
	vTemp.x = this->x / s;
	vTemp.y = this->y / s;
	vTemp.z = this->z / s;
	return vTemp;			
}

const vector &vector::operator /= (const float &s) 
{
	vector vTemp;
	this->x = this->x / s;
	this->y = this->y / s;
	this->z = this->z / s;
	return *this;			
}