#pragma once
#define output 1
#include <iostream>
#include <fstream>
#include <string>
#include <list>
#include "RTG.h"

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
//constructor
RTG::RTG()
{
#if output == 1
	std::cout << "RTG: Creating RTG-object instance...";
#endif

	iNUMBER_OF_OBJECTS = 0;
	iNumberOfFrames = 0;

	iNumberOfVertices = 0;
	iNumberOfPolygons = 0;
	iNumberOfNormals = 0;
	iNumberOfTextureCoordinates = 0;

	iTotalNumberOfVertices = 0;
	iTotalNumberOfPolygons = 0;
	iTotalNumberOfNormals = 0;
	iTotalNumberOfTextureCoordinates = 0;

	iNumberOfVertices = NULL;
	iNumberOfPolygons = NULL;
	iNumberOfNormals = NULL;
	iNumberOfTextureCoordinates = NULL;

	aVertices = NULL;
	aPolygons = NULL;
	aNumberOfPolygonEdges = NULL;
	aPolygonColors = NULL;
	aNormals = NULL;
	aTextureCoordinates = NULL;
	aVertexColors = NULL;

	definedVertices = false;
	definedPolygonAttributes = false;
	definedNormals = false;
	definedVertexColors = false;
	definedTextureCoordinates = false;
	definedPolygonColors = false;

	printVertices = false;
	printPolygonAttributes = false;
	printPolygonColors = false;
	printNormals = false;
	printTextureCoordinates = false;
	printVertexColors = false;

	bRtgExist = false;
	bOUTPUT_VERT_NORMS = false;
	bOUTPUT_VERT_COLORS = false;
	bOUTPUT_TEX_COORDS = false;
	bOUTPUT_POLY_NORMS = false;
	bOUTPUT_HIERARCHY = false;
	bOUTPUT_LOCAL = false;
	bSHOW_INDEX_COUNTERS = false;
	bOUTPUT_MATERIALS = false;
	bOUTPUT_ANIMATION = false;
	bOUTPUT_ALL_NODES = false;
	bOUTPUT_DECOMP = false;
	bOUTPUT_DEGREES = false;

#if output == 1
	std::cout << "done" << std::endl;
#endif
}

RTG::RTG(std::string sRtgPath)
{
#if output == 1
	std::cout << "RTG: Creating RTG-object instance...";
#endif

	setRtgPath(sRtgPath);
	iNUMBER_OF_OBJECTS = 0;
	iNumberOfFrames = 0;

	iNumberOfVertices = 0;
	iNumberOfPolygons = 0;
	iNumberOfNormals = 0;
	iNumberOfTextureCoordinates = 0;

	iTotalNumberOfVertices = 0;
	iTotalNumberOfPolygons = 0;
	iTotalNumberOfNormals = 0;
	iTotalNumberOfTextureCoordinates = 0;

	iNumberOfVertices = NULL;
	iNumberOfPolygons = NULL;
	iNumberOfNormals = NULL;
	iNumberOfTextureCoordinates = NULL;

	aVertices = NULL;
	aPolygons = NULL;
	aNumberOfPolygonEdges = NULL;
	aPolygonColors = NULL;
	aNormals = NULL;
	aTextureCoordinates = NULL;
	aVertexColors = NULL;

	definedVertices = false;
	definedPolygonAttributes = false;
	definedNormals = false;
	definedVertexColors = false;
	definedTextureCoordinates = false;
	definedPolygonColors = false;

	printVertices = false;
	printPolygonAttributes = false;
	printPolygonColors = false;
	printNormals = false;
	printTextureCoordinates = false;
	printVertexColors = false;

	bRtgExist = false;
	bOUTPUT_VERT_NORMS = false;
	bOUTPUT_VERT_COLORS = false;
	bOUTPUT_TEX_COORDS = false;
	bOUTPUT_POLY_NORMS = false;
	bOUTPUT_HIERARCHY = false;
	bOUTPUT_LOCAL = false;
	bSHOW_INDEX_COUNTERS = false;
	bOUTPUT_MATERIALS = false;
	bOUTPUT_ANIMATION = false;
	bOUTPUT_ALL_NODES = false;
	bOUTPUT_DECOMP = false;
	bOUTPUT_DEGREES = false;

#if output == 1
	std::cout << "done" << std::endl;
#endif
}

/////////////////////////////////////////////////////////////////
//destructor
RTG::~RTG()
{
	if (iNumberOfVertices != NULL)
	{
		delete [] iNumberOfVertices;
	}

	if (iNumberOfPolygons != NULL)
	{
		delete [] iNumberOfPolygons;
	}

	if (iNumberOfNormals != NULL)
	{
		delete [] iNumberOfNormals;
	}

	if (iNumberOfTextureCoordinates != NULL)
	{
		delete [] iNumberOfTextureCoordinates;
	}

	if (aVertices != NULL)
	{
		delete [] aVertices;
	}

	if (aPolygons != NULL)
	{
		delete [] aPolygons;
	}

	if (aNumberOfPolygonEdges != NULL)
	{
		delete [] aNumberOfPolygonEdges;
	}

	if (aPolygonColors != NULL)
	{
		delete [] aPolygonColors;
	}

	if (aNormals != NULL)
	{
		delete [] aNormals;
	}

	if (aTextureCoordinates != NULL)
	{
		delete [] aTextureCoordinates;
	}

	if (aVertexColors != NULL)
	{
		delete [] aVertexColors;
	}
}

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
void RTG::printRtgInfo()
{
	std::cout << std::endl;
	std::cout << "--------------------RTG--------------------" << std::endl;
	std::cout << "-------------------------------------------" << std::endl;
	std::cout << "RTG export file: " << getRtgPath() << std::endl;
	std::cout << "Exported scene objects: " << iNUMBER_OF_OBJECTS << std::endl;
	std::cout << "Exported animation frames: " << getNumberOfFrames() << std::endl;
	std::cout << "Total number of vertices: " << getTotalNumberOfVertices() << std::endl;
	std::cout << "Total number of polygons: " << getTotalNumberOfPolygons() << std::endl;
	std::cout << "Total number of normals: " << getTotalNumberOfNormals() << std::endl;
	std::cout << "Total number of texture coordinates: " << getTotalNumberOfTextureCoordinates() << std::endl;
	std::cout << std::endl;
	std::cout << "RTG: Export attributes:" << std::endl;
	std::cout << std::endl;
	std::cout << "\tOUTPUT_VERT_NORMS " << bOUTPUT_VERT_NORMS << std::endl;
	std::cout << "\tOUTPUT_VERT_COLORS " << bOUTPUT_VERT_COLORS << std::endl;
	std::cout << "\tOUTPUT_TEX_COORDS " << bOUTPUT_TEX_COORDS << std::endl;
	std::cout << "\tOUTPUT_POLY_NORMS " << bOUTPUT_POLY_NORMS << std::endl;
	std::cout << "\tOUTPUT_HIERARCHY " << bOUTPUT_HIERARCHY << std::endl;
	std::cout << "\tOUTPUT_LOCAL " << bOUTPUT_LOCAL << std::endl;
	std::cout << "\tSHOW_INDEX_COUNTERS " << bSHOW_INDEX_COUNTERS << std::endl;
	std::cout << "\tOUTPUT_MATERIALS " << bOUTPUT_MATERIALS << std::endl;
	std::cout << "\tOUTPUT_ANIMATION " << bOUTPUT_ANIMATION << std::endl;
	std::cout << "\tOUTPUT_ALL_NODES " << bOUTPUT_ALL_NODES << std::endl;
	std::cout << "\tOUTPUT_DECOMP " << bOUTPUT_DECOMP << std::endl;
	std::cout << "\tOUTPUT_DEGREES " << bOUTPUT_DEGREES << std::endl;
	std::cout << std::endl;
}

/////////////////////////////////////////////////////////////////
void RTG::printObjectInfo()
{
	for (unsigned short int objectCount = 0; objectCount < iNUMBER_OF_OBJECTS; objectCount++)
	{
		std::cout << std::endl;
		std::cout << "-----------------RTG-object----------------" << std::endl;
		std::cout << "-------------------------------------------" << std::endl;
		std::cout << "RTG export file: " << getRtgPath() << std::endl;
		std::cout << std::endl;
		std::cout << "RTG: Object " << (objectCount + 1) << " attributes:" << std::endl;
		std::cout << std::endl;
		std::cout << "\tObject name:" << strObjectName[objectCount] << std::endl;
		std::cout << "\tNumber of vertices:" << iNumberOfVertices[objectCount] << std::endl;
		std::cout << "\tNumber of polygons:" << iNumberOfPolygons[objectCount] << std::endl;
		std::cout << "\tNumber of vertex normals:" << iNumberOfNormals[objectCount] << std::endl;
		std::cout << "\tNumber of texture coordinates:" << iNumberOfTextureCoordinates[objectCount] << std::endl;
		std::cout << std::endl;
	}
}

/////////////////////////////////////////////////////////////////
void RTG::printArrays()
{
	if (definedVertices == true && printVertices == true)
	{
		std::cout << "------------------VERTICES-----------------" << std::endl;
		std::cout << "-------------------------------------------" << std::endl;
	
		for (unsigned long int i = 0; i < getTotalNumberOfVertices(); i++)
		{
			std::cout << i << ": ";
			std::cout << aVertices [i][0] << "  ";
			std::cout << aVertices [i][1] << "  ";
			std::cout << aVertices [i][2] << std::endl;
		}
		std::cout << std::endl;
	}

	if (definedPolygonAttributes == true && printPolygonAttributes == true)
	{
		std::cout << "------------------POLYGONS-----------------" << std::endl;
		std::cout << "-------------------------------------------" << std::endl;

		for (unsigned int i = 0; i < getTotalNumberOfPolygons(); i++)
		{
			std::cout << i << ": ";
	
			for (unsigned short int j = 0; j < aNumberOfPolygonEdges[i]; j++)
			{
				std::cout << aPolygons[i][j] << "  ";
			}
			std::cout << std::endl;
		}

		std::cout << std::endl;
	}

	if (definedNormals == true && printNormals == true)
	{
		std::cout << "--------------VERTEX NORMALS---------------" << std::endl;
		std::cout << "-------------------------------------------" << std::endl;
		
		for (unsigned long int i = 0; i < getTotalNumberOfNormals(); i++)
		{
			std::cout << i << ": ";
			std::cout << aNormals [i][0] << "  ";
			std::cout << aNormals [i][1] << "  ";
			std::cout << aNormals [i][2] << std::endl;
		}

		std::cout << std::endl;
	}

	if (definedTextureCoordinates == true && printTextureCoordinates == true)
	{
		std::cout << "------------TEXTURE COORDINATES------------" << std::endl;
		std::cout << "-------------------------------------------" << std::endl;

		for (unsigned long int i = 0; i < getTotalNumberOfTextureCoordinates(); i++)
		{
			std::cout << i << ": ";
			std::cout << aTextureCoordinates[i][0] << "  ";
			std::cout << aTextureCoordinates[i][1] << std::endl;
		}

		std::cout << "" << std::endl;
	}

	if (definedVertexColors == true && printVertexColors == true)
	{
		std::cout << "---------------VERTEX COLORS---------------" << std::endl;
		std::cout << "-------------------------------------------" << std::endl;

		for (unsigned long int i = 0; i < (getTotalNumberOfPolygons() * 3); i++)
		{
			std::cout << i << ": ";
			std::cout << aVertexColors[i][0] << "  ";
			std::cout << aVertexColors[i][1] << "  ";
			std::cout << aVertexColors[i][2] << "  ";
			std::cout << aVertexColors[i][3] << std::endl;
		}
	}
}

/////////////////////////////////////////////////////////////////
void RTG::setRtgPath(std::string path)
{
	strRtgPath = path;
}

/////////////////////////////////////////////////////////////////
std::string RTG::getRtgPath()
{
	return strRtgPath;
}

/////////////////////////////////////////////////////////////////
//check if the RTG-file exists
void RTG::analyzeRtgFile()
{
	std::cout << "Analyzing specified RTG-file." << std::endl;
	//creates file stream and opens specified file for reading
	std::fstream finRtg(getRtgPath().c_str(), std::ios::in);

	//if opening the specified file failed
	if (finRtg.good() != true)
	{
		std::cout << std::endl;
		std::cout << "--------------RTG FILE ERROR!--------------" << std::endl;
		std::cout << "-------------------------------------------" << std::endl;
		std::cerr << "RTG-file: " << getRtgPath() << " failed to open." << std::endl;
	}
	//if opening the specified file was successful
	else
	{
		bRtgExist = true;
		finRtg.close();

		checkAttributes();
		getObjectAttributes();
	}
}

/////////////////////////////////////////////////////////////////
//check through all the attributes
void RTG::checkAttributes()
{
	std::string strTemp("");
	//creates file stream and opens specified file for reading
	std::fstream finRtg(getRtgPath().c_str(), std::ios::in);

	//go to position in RTG-file where we find the string "OUTPUT_VERT_NORMS"
	while (strTemp != "OUTPUT_VERT_NORMS")
	{	
		finRtg >> strTemp;
	}

	//check OUTPUT_VERT_NORMS
	finRtg >> strTemp;
		
	if (strTemp == "on")
	{
		bOUTPUT_VERT_NORMS = true;
	}
	else
	{
		bOUTPUT_VERT_NORMS = false;
	}

	//check OUTPUT_VERT_COLORS
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_VERT_COLORS = true;
	}
	else
	{
		bOUTPUT_VERT_COLORS = false;
	}

	//check OUTPUT_TEX_COORDS
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_TEX_COORDS = true;
	}
	else
	{
		bOUTPUT_TEX_COORDS = false;
	}

	//check OUTPUT_POLY_NORMS
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_POLY_NORMS = true;
	}
	else
	{
		bOUTPUT_POLY_NORMS = false;
	}

	//check OUTPUT_HIERARCHY
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_HIERARCHY = true;
	}
	else
	{
		bOUTPUT_HIERARCHY = false;
	}
	
	//check OUTPUT_LOCAL
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_LOCAL = true;
	}
	else
	{
		bOUTPUT_LOCAL = false;
	}

	//check SHOW_INDEX_COUNTERS
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bSHOW_INDEX_COUNTERS = true;
	}
	else
	{
		bSHOW_INDEX_COUNTERS = false;
	}

	//check OUTPUT_MATERIALS
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_MATERIALS = true;
	}
	else
	{
		bOUTPUT_MATERIALS = false;
	}

	//check OUTPUT_ANIMATION
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_ANIMATION = true;
	}
	else
	{
		bOUTPUT_ANIMATION = false;
	}

	//check OUTPUT_ALL_NODES
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_ALL_NODES = true;
	}
	else
	{
		bOUTPUT_ALL_NODES = false;
	}

	//check OUTPUT_DECOMP
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_DECOMP = true;
	}
	else
	{
		bOUTPUT_DECOMP = false;
	}

	//check OUTPUT_DEGREES
	finRtg >> strTemp >> strTemp;
	
	if (strTemp == "on")
	{
		bOUTPUT_DEGREES = true;
	}
	else
	{
		bOUTPUT_DEGREES = false;
	}

	//close RTG-file
	finRtg.close();

	getNumberOfFrames();
	getNumberOfObjects();
}

/////////////////////////////////////////////////////////////////
unsigned short int RTG::getNumberOfObjects()
{
	unsigned short int nObjects = 0;
	std::string strTemp("");
	//creates file stream and opens specified file for reading
	std::fstream finRtg(getRtgPath().c_str(), std::ios::in);

	//go to position in RTG-file where we find the string "NUMBER_OF_OBJECTS"
	while (strTemp != "NUMBER_OF_OBJECTS")
	{
		finRtg >> strTemp;
	}

	finRtg >> nObjects;

	//close rtg-file
	finRtg.close();
	iNUMBER_OF_OBJECTS = nObjects;

	strObjectName = new std::string[nObjects];
	iNumberOfVertices = new unsigned long int[nObjects];
	iNumberOfPolygons = new unsigned long int[nObjects];
	iNumberOfNormals = new unsigned long int[nObjects];
	iNumberOfTextureCoordinates = new unsigned long int[nObjects];

	//reads in the object names
	getAllObjectNames();

	return iNUMBER_OF_OBJECTS;
}

/////////////////////////////////////////////////////////////////
void RTG::getAllObjectNames()
{
	unsigned short int objectCount = 0;
	std::string strTemp = ("");
	//creates file stream and opens specified file for reading
	std::fstream finRtg(getRtgPath().c_str(), std::ios::in);

	while (finRtg.eof() != true)
	{
		finRtg >> strTemp;

		if (strTemp == "OBJECT_START")
		{
			finRtg >> strTemp;
			strObjectName[objectCount] = strTemp;
			objectCount++;
		}
	}

	//close the RTG-file
	finRtg.close();
}

/////////////////////////////////////////////////////////////////
unsigned short int RTG::getNumberOfFrames()
{
	unsigned short int iFrameCount = 0;
	bool bAnimationList = false;
	std::string strTemp("");
	std::string strTemp2("");
	//creates file stream and opens specified file for reading
	std::fstream finRtg(getRtgPath().c_str(), std::ios::in);

	if (bOUTPUT_ANIMATION == true)
	{
		while (finRtg.eof() != true)
		{
			finRtg >> strTemp;

			//makes sure that we only start to look for the string "FRAME" when we're in
			//the ANIMATION_LIST. this prevents messing up the frame counter if there
			//is an object in the scene-file which is called "FRAME"
			if (strTemp == "ANIMATION_LIST")
			{
				bAnimationList = true;
			}

			if (bAnimationList == true)
			{
				//makes sure that we don't increase the frame counter when an object
				//in the scene file is called "FRAME".
				//if there is an object calles "FRAME", we store the next instream into
				//strTemp2 which can just be disregarded
				if (strTemp == "OBJECT")
				{
					finRtg >> strTemp2;
				}

				if (strTemp == "FRAME")
				{
					iFrameCount++;
				}
			}
		}
	}

	iNumberOfFrames = iFrameCount;

	//close the RTG-file
	finRtg.close();

	//we return the total number of animation frames that were exported
	return iFrameCount;
}

/////////////////////////////////////////////////////////////////
void RTG::getObjectAttributes()
{
	unsigned short int objectCount = 0;
	std::string strTemp = ("");
	unsigned int iTemp = 0;
	//creates file stream and opens specified file for reading
	std::fstream finRtg(getRtgPath().c_str(), std::ios::in);

	while (finRtg.eof() != true)
	{
		finRtg >> strTemp;

		if (strTemp == "OBJECT_START")
		{
			finRtg >> strTemp;

			//read # of vertices
			//advances the file pointer to spaces to be able to read just the number of vertices
			finRtg.seekg(2, std::ios::cur);
			finRtg >> iTemp;
			iNumberOfVertices[objectCount] = iTemp;
			iTotalNumberOfVertices = iTotalNumberOfVertices + iTemp;

			if(bOUTPUT_VERT_NORMS == true)
			{
				//read # of normals
				//advances the file pointer to spaces to be able to read just the number of normals
				finRtg.seekg(2, std::ios::cur);
				finRtg >> iTemp;
				iNumberOfNormals[objectCount] = iTemp;
				iTotalNumberOfNormals = iTotalNumberOfNormals + iTemp;
			}
			//if the vertex normals were not exported
			else
			{
				iNumberOfNormals[objectCount] = 0;
				finRtg.seekg(1, std::ios::cur);
			}

			if(bOUTPUT_TEX_COORDS == true)
			{
				//read # of texture coordinates
				//advances the file pointer to spaces to be able to read just the number of texture coordinates
				finRtg.seekg(2, std::ios::cur);
				finRtg >> iTemp;
				iNumberOfTextureCoordinates[objectCount] = iTemp;
				iTotalNumberOfTextureCoordinates = iTotalNumberOfTextureCoordinates + iTemp;
			}
			//if the texture coordinates were not exported
			else
			{
				iNumberOfTextureCoordinates[objectCount] = 0;
				finRtg.seekg(1, std::ios::cur);
			}

			//read # of polygons
			//advances the file pointer to spaces to be able to read just the number of polygons
			finRtg.seekg(2, std::ios::cur);
			finRtg >> iTemp;
			iNumberOfPolygons[objectCount] = iTemp;
			iTotalNumberOfPolygons = iTotalNumberOfPolygons + iTemp;

			objectCount++;
		}
	}

	//close the RTG-file
	finRtg.close();
}

/////////////////////////////////////////////////////////////////
void RTG::getVertices(bool pVertices)
{
	aVertices = new float*[getTotalNumberOfVertices()];

	unsigned short int objectCount = 0;
	unsigned long int vertexCount = 0;
	std::string strTemp = ("");
	float fTemp = 0;

	//creates file stream and opens specified file for reading
	std::fstream finRtg(getRtgPath().c_str(), std::ios::in);

	while (finRtg.eof() != true)
	{
		finRtg >> strTemp;

		if (strTemp == "OBJECT_START")
		{
			finRtg >> strTemp >> strTemp;

			while (strTemp != "VERTEX")
			{
				finRtg >> strTemp;
			}

			finRtg >> strTemp;

			for (unsigned short int i = 0; i < getNumberOfVertices(objectCount); i++)
			{
				if (bSHOW_INDEX_COUNTERS == true)
				{
					finRtg >> fTemp;
					aVertices[vertexCount] = new float[3];
					
					finRtg >> fTemp;
					aVertices[vertexCount][0] = fTemp;
					finRtg >> fTemp;
					aVertices[vertexCount][1] = fTemp;
					finRtg >> fTemp;
					aVertices[vertexCount][2] = fTemp;
				}
				else
				{
					aVertices[vertexCount] = new float[3];

					finRtg >> fTemp;
					aVertices[vertexCount][0] = fTemp;
					finRtg >> fTemp;
					aVertices[vertexCount][1] = fTemp;
					finRtg >> fTemp;
					aVertices[vertexCount][2] = fTemp;
				}
				vertexCount++;
			}
			objectCount++;
		}
	}

	//close the RTG-file
	finRtg.close();

	printVertices = pVertices;
	definedVertices = true;
}

/////////////////////////////////////////////////////////////////
void RTG::getPolygonAttributes(bool pPolygonAttributes)
{
	aPolygons = new int*[getTotalNumberOfPolygons()];
	aNumberOfPolygonEdges = new int[getTotalNumberOfPolygons()];

	unsigned short int objectCount = 0;
	unsigned long int polygonCount = 0;
	unsigned short int polygonEdgeCount = 0;
	std::string strTemp = ("");
	int iTemp = 0;

	//creates file stream and opens specified file for reading
	std::fstream finRtg(getRtgPath().c_str(), std::ios::in);

	while (finRtg.eof() != true)
	{
		finRtg >> strTemp;

		if (strTemp == "OBJECT_START")
		{
			finRtg >> strTemp >> strTemp;

			while (strTemp != "POLYGON")
			{
				finRtg >> strTemp;
			}

			while (strTemp != "v")
			{
				finRtg >> strTemp;
			}

			for (unsigned long int i = 0; i < getNumberOfPolygons(objectCount); i++)
			{
				while (strTemp != "RGB" && strTemp != "n" && strTemp != "t" && strTemp != "T")
				{
					finRtg >> strTemp;
					polygonEdgeCount++;
				}

				if (i != (getNumberOfPolygons(objectCount) - 1))
				{
					while (strTemp != "v")
					{
						finRtg >> strTemp;
					}
				}

				polygonEdgeCount = (polygonEdgeCount - 1);

				aPolygons[polygonCount] = new int[polygonEdgeCount];
				aNumberOfPolygonEdges[polygonCount] = polygonEdgeCount;

				polygonEdgeCount = 0;
				polygonCount++;
			}
			objectCount++;
		}
	}

	//close the RTG-file
	finRtg.close();

	//creates file stream and opens specified file for reading
	std::fstream finRtgB(getRtgPath().c_str(), std::ios::in);	

	polygonCount = 0;
	objectCount = 0;

	//initialize all polygonEdges to 0
	for (unsigned int i = 0; i < getTotalNumberOfPolygons(); i++)
	{
		for (unsigned short int j = 0; j < aNumberOfPolygonEdges[i]; j++)
		{
			aPolygons[i][j] = 0;
		}
	}

	while (polygonCount != getTotalNumberOfPolygons())
	{
		finRtgB >> strTemp;

		if (strTemp == "OBJECT_START")
		{
			finRtgB >> strTemp >> strTemp;

			while (strTemp != "POLYGON")
			{
				finRtgB >> strTemp;
			}

			while (strTemp != "v")
			{
				finRtgB >> strTemp;
			}

			for (unsigned long int i = 0; i < getNumberOfPolygons(objectCount); i++)
			{
				for (unsigned short j = 0; j < aNumberOfPolygonEdges[polygonCount]; j++)
				{
					finRtgB >> iTemp;
					aPolygons[polygonCount][j] = iTemp;
				}

				finRtgB >> strTemp;

				if (i != (getNumberOfPolygons(objectCount) - 1))
				{
					while (strTemp != "v")
					{
						finRtgB >> strTemp;
					}
				}
				polygonCount++;
			}
			objectCount++;
		}
	}

	//close the RTG-file
	finRtgB.close();

	printPolygonAttributes = pPolygonAttributes;
	definedPolygonAttributes = true;
}

/////////////////////////////////////////////////////////////////
void RTG::getNormals(bool pNormals)
{
	aNormals = new float*[getTotalNumberOfNormals()];

	unsigned short int objectCount = 0;
	unsigned long int normalCount = 0;
	std::string strTemp = ("");
	float fTemp = 0;

	if (bOUTPUT_VERT_NORMS == true)
	{
		//creates file stream and opens specified file for reading
		std::fstream finRtg(getRtgPath().c_str(), std::ios::in);
	
		while (finRtg.eof() != true)
		{
			finRtg >> strTemp;
	
			if (strTemp == "OBJECT_START")
			{
				finRtg >> strTemp >> strTemp;
	
				while (strTemp != "NORMAL")
				{
					finRtg >> strTemp;
				}
	
				for (unsigned short int i = 0; i < getNumberOfNormals(objectCount); i++)
				{
					if (bSHOW_INDEX_COUNTERS == true)
					{
						finRtg >> fTemp;
						aNormals[normalCount] = new float[3];
						
						finRtg >> fTemp;
						aNormals[normalCount][0] = fTemp;
						finRtg >> fTemp;
						aNormals[normalCount][1] = fTemp;	
						finRtg >> fTemp;
						aNormals[normalCount][2] = fTemp;
					}
					else
					{
						aNormals[normalCount] = new float[3];
						
						finRtg >> fTemp;
						aNormals[normalCount][0] = fTemp;
						finRtg >> fTemp;
						aNormals[normalCount][1] = fTemp;
						finRtg >> fTemp;
						aNormals[normalCount][2] = fTemp;
					}
					normalCount++;
				}
				objectCount++;
			}
		}

		//close the RTG-file
		finRtg.close();

		printNormals = pNormals;
		definedNormals = true;
	}
}

/////////////////////////////////////////////////////////////////
void RTG::getTextureCoordinates(bool pTextureCoordinates)
{
	aTextureCoordinates = new float*[getTotalNumberOfTextureCoordinates()];

	unsigned short int objectCount = 0;
	unsigned long int textureCoordinateCount = 0;
	std::string strTemp = ("");
	float fTemp = 0;

	if (bOUTPUT_TEX_COORDS == true)
	{
		//creates file stream and opens specified file for reading
		std::fstream finRtg(getRtgPath().c_str(), std::ios::in);
	
		while (finRtg.eof() != true)
		{
			finRtg >> strTemp;
	
			if (strTemp == "OBJECT_START")
			{
				finRtg >> strTemp >> strTemp;
	
				while (strTemp != "TEXCOORD")
				{
					finRtg >> strTemp;
				}
	
				for (unsigned short int i = 0; i < getNumberOfTextureCoordinates(objectCount); i++)
				{
					if (bSHOW_INDEX_COUNTERS == true)
					{
						finRtg >> fTemp;
						aTextureCoordinates[textureCoordinateCount] = new float[2];
						
						finRtg >> fTemp;
						aTextureCoordinates[textureCoordinateCount][0] = fTemp;
						finRtg >> fTemp;
						aTextureCoordinates[textureCoordinateCount][1] = fTemp;	
					}
					else
					{
						aTextureCoordinates[textureCoordinateCount] = new float[2];
						
						finRtg >> fTemp;
						aTextureCoordinates[textureCoordinateCount][0] = fTemp;
						finRtg >> fTemp;
						aTextureCoordinates[textureCoordinateCount][1] = fTemp;
					}
					textureCoordinateCount++;
				}
				objectCount++;
			}
		}

		//close the RTG-file
		finRtg.close();

		printTextureCoordinates = pTextureCoordinates;
		definedTextureCoordinates = true;
	}
}

/////////////////////////////////////////////////////////////////
void RTG::getVertexColors(bool pVertexColors)
{
	aVertexColors = new int*[(getTotalNumberOfPolygons() * 3)];

	unsigned short int objectCount = 0;
	unsigned long int colorCount = 0;
	std::string strTemp = ("");
	int iTemp = 0;

	if (bOUTPUT_VERT_COLORS == true)
	{
		//creates file stream and opens specified file for reading
		std::fstream finRtg(getRtgPath().c_str(), std::ios::in);
	
		while (finRtg.eof() != true)
		{
			finRtg >> strTemp;
	
			if (strTemp == "OBJECT_START")
			{
				finRtg >> strTemp >> strTemp;
	
				while (strTemp != "COLORS")
				{
					finRtg >> strTemp;
				}
	
				for (unsigned short int i = 0; i < (getNumberOfPolygons(objectCount) * 3); i++)
				{
					if (bSHOW_INDEX_COUNTERS == true)
					{
						finRtg >> iTemp;
						aVertexColors[colorCount] = new int[4];
						
						finRtg >> iTemp;
						aVertexColors[colorCount][0] = iTemp;
						finRtg >> iTemp;
						aVertexColors[colorCount][1] = iTemp;
						finRtg >> iTemp;
						aVertexColors[colorCount][2] = iTemp;
						finRtg >> iTemp;
						aVertexColors[colorCount][3] = iTemp;	
					}
					else
					{
						aVertexColors[colorCount] = new int[4];
						
						finRtg >> iTemp;
						aVertexColors[colorCount][0] = iTemp;
						finRtg >> iTemp;
						aVertexColors[colorCount][1] = iTemp;
						finRtg >> iTemp;
						aVertexColors[colorCount][2] = iTemp;
						finRtg >> iTemp;
						aVertexColors[colorCount][3] = iTemp;
					}
					colorCount++;
				}
				objectCount++;
			}
		}

		//close the RTG-file
		finRtg.close();

		printVertexColors = pVertexColors;
		definedVertexColors = true;
	}
}

/////////////////////////////////////////////////////////////////
void RTG::drawObject(unsigned short int nObject)
{
	if (definedVertices == false ||	definedPolygonAttributes == false || nObject > (iNUMBER_OF_OBJECTS - 1))
	{
		std::cout << "-----------------RTG ERROR-----------------" << std::endl;
		std::cout << "-------------------------------------------" << std::endl;
		std::cerr << "***Failed to draw object!***" << std::endl;
		std::cerr << "Please gather vertex positions and polygon attributes first." << std::endl;
		std::cerr << "Make sure that the object called to be drawn doesn't exceed\nthe total number of objects." << std::endl;
	}
	else
	{
		unsigned long int polygonOffset = 0;
		unsigned long int vertexOffset = 0;
		unsigned long int numberOfVertices = 0;
		unsigned long int numberOfFaces = 0;
		float vertexPosition[3];

		for (unsigned short int objectCount = 0; objectCount < nObject; objectCount++)
		{
			polygonOffset = (polygonOffset + getNumberOfPolygons(objectCount));
			vertexOffset = (vertexOffset + getNumberOfVertices(objectCount));
		}

#if output == 1
		std::cout << "-----------------RTG DRAW------------------" << std::endl;
		std::cout << "-------------------------------------------" << std::endl;
		std::cout << "Drawing object " << nObject << ": " << strObjectName[nObject] << std::endl;
		std::cout << "polygon offset: " << polygonOffset << std::endl;
		std::cout << "vertex offset: " << vertexOffset << std::endl;
		std::cout << "starting @ polygon: " << polygonOffset << std::endl;
		std::cout << "starting @ vertex: " << vertexOffset << std::endl;
#endif

		numberOfFaces = getNumberOfPolygons(nObject);
		numberOfVertices = getNumberOfVertices(nObject);

#if output == 1
		std::cout << "nFaces: " << numberOfFaces << std::endl;
		std::cout << "nVertices: " << numberOfVertices << std::endl;
#endif

		for (unsigned long int i = 0; i < numberOfFaces; i++)
		{
			for (unsigned short int j = 0; j < aNumberOfPolygonEdges[(polygonOffset + i)]; j++)
			{
				vertexPosition[0] = aVertices[(vertexOffset + aPolygons[(polygonOffset + i)][j])][0];
				vertexPosition[1] = aVertices[(vertexOffset + aPolygons[(polygonOffset + i)][j])][1];
				vertexPosition[2] = aVertices[(vertexOffset + aPolygons[(polygonOffset + i)][j])][2];
#if output == 1
				std::cout << j << ": " << aPolygons[(polygonOffset + i)][j] << "\t" << vertexPosition[0] << " " << vertexPosition[1] << " " << vertexPosition[2]<< std::endl;
#endif
			}
#if output == 1
			std::cout << std::endl;
#endif
		}
	}
}

/////////////////////////////////////////////////////////////////
void RTG::drawScene()
{
	for (unsigned short int i = 0; i < iNUMBER_OF_OBJECTS; i++)
	{
		drawObject(i);
	}
}

/////////////////////////////////////////////////////////////////
std::string RTG::getObjectName(unsigned short int objectNumber)
{
	return strObjectName[objectNumber];
}

/////////////////////////////////////////////////////////////////
unsigned long int RTG::getNumberOfVertices(unsigned short int objectNumber)
{
	return iNumberOfVertices[objectNumber];
}

/////////////////////////////////////////////////////////////////
unsigned long int RTG::getNumberOfPolygons(unsigned short int objectNumber)
{
	return iNumberOfPolygons[objectNumber];
}

/////////////////////////////////////////////////////////////////
unsigned long int RTG::getNumberOfNormals(unsigned short int objectNumber)
{
	return iNumberOfNormals[objectNumber];
}

/////////////////////////////////////////////////////////////////
unsigned long int RTG::getNumberOfTextureCoordinates(unsigned short int objectNumber)
{
	return iNumberOfTextureCoordinates[objectNumber];
}

/////////////////////////////////////////////////////////////////
unsigned long int RTG::getTotalNumberOfVertices()
{
	return iTotalNumberOfVertices;
}

/////////////////////////////////////////////////////////////////
unsigned long int RTG::getTotalNumberOfPolygons()
{
	return iTotalNumberOfPolygons;
}

/////////////////////////////////////////////////////////////////
unsigned long int RTG::getTotalNumberOfNormals()
{
	return iTotalNumberOfNormals;
}

/////////////////////////////////////////////////////////////////
unsigned long int RTG::getTotalNumberOfTextureCoordinates()
{
	return iTotalNumberOfTextureCoordinates;
}