/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
class RTG
{
public:
	RTG();
	//constructor
	RTG(std::string strRtgPath);
	//destructor
	~RTG();

	////////////////////////
	//functions
	void analyzeRtgFile();
	void checkAttributes();

	unsigned short int getNumberOfObjects();
	unsigned short int getNumberOfFrames();

	void setRtgPath(std::string path);
	std::string getRtgPath();

	void getAllObjectNames();
	std::string getObjectName(unsigned short int objectNumber);

	void getObjectAttributes();
	void getVertices(bool pVertices);
	void getPolygonAttributes(bool pPolygonAttributes);
	void getPolygonColors(bool pPolygonColors);
	void getNormals(bool pNormals);
	void getTextureCoordinates(bool pTextureCoordinates);
	void getVertexColors(bool pVertexColors);

	bool printVertices;
	bool printPolygonAttributes;
	bool printPolygonColors;
	bool printNormals;
	bool printTextureCoordinates;
	bool printVertexColors;

	//boolean variables to keep track if the certain function has been executed
	//just to make sure we don't crash the program when we're printing stuff
	bool definedVertices;
	bool definedPolygonAttributes;
	bool definedNormals;
	bool definedVertexColors;
	bool definedTextureCoordinates;
	bool definedPolygonColors;

	unsigned long int getNumberOfVertices(unsigned short int objectNumber);
	unsigned long int getNumberOfPolygons(unsigned short int objectNumber);
	unsigned long int getNumberOfNormals(unsigned short int objectNumber);
	unsigned long int getNumberOfTextureCoordinates(unsigned short int objectNumber);

	unsigned long int getTotalNumberOfVertices();
	unsigned long int getTotalNumberOfPolygons();
	unsigned long int getTotalNumberOfNormals();
	unsigned long int getTotalNumberOfTextureCoordinates();

	void drawObject(unsigned short int nObject);
	void drawScene();
	void printRtgInfo();
	void printObjectInfo();
	void printArrays();

	////////////////////////
	//variables
	bool bRtgExist;
	bool bOUTPUT_VERT_NORMS;
	bool bOUTPUT_VERT_COLORS;
	bool bOUTPUT_TEX_COORDS;
	bool bOUTPUT_POLY_NORMS;
	bool bOUTPUT_HIERARCHY;
	bool bOUTPUT_LOCAL;
	bool bSHOW_INDEX_COUNTERS;
	bool bOUTPUT_MATERIALS;
	bool bOUTPUT_ANIMATION;
	bool bOUTPUT_ALL_NODES;
	bool bOUTPUT_DECOMP;
	bool bOUTPUT_DEGREES;

	std::string strRtgPath;
	//list to store all object names
	std::string * strObjectName;
	unsigned short int iNUMBER_OF_OBJECTS;
	unsigned short int iNumberOfFrames;
	unsigned long int * iNumberOfVertices;
	unsigned long int * iNumberOfPolygons;
	unsigned long int * iNumberOfNormals;
	unsigned long int * iNumberOfTextureCoordinates;

	float ** aVertices;
	int ** aPolygons;
	int * aNumberOfPolygonEdges;
	int ** aPolygonColors;
	float ** aNormals;
	float ** aTextureCoordinates;
	int ** aVertexColors;

	unsigned long int iTotalNumberOfVertices;
	unsigned long int iTotalNumberOfPolygons;
	unsigned long int iTotalNumberOfNormals;
	unsigned long int iTotalNumberOfTextureCoordinates;

private:
};