#pragma once
#include <iostream>
#include <string>
#include "menu.h"

////////////////////////////////////////////////////////////////////////////////////
menu::menu()
{
	menuItem = ' ';
	customObject = false;
	rtgPath = "";
	pPathFile = "";
	pColorFile = "";
	pScaleFile = "";
	pOpacityFile = "";
}

menu::~menu()
{
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getRtgPath()
{
	return rtgPath;
}

////////////////////////////////////////////////////////////////////////////////////
void menu::setRtgPath(std::string rtgPathFile)
{
	rtgPath = rtgPathFile;
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getpPathFile()
{
	return pPathFile;
}

void menu::setpPathFile(std::string pPathF)
{
	pPathFile = pPathF;
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getpColorFile()
{
	return pColorFile;
}

void menu::setpColorFile(std::string pColorF)
{
	pColorFile = pColorF;
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getpOpacityFile()
{
	return pOpacityFile;
}

void menu::setpOpacityFile(std::string pOpacityF)
{
	pOpacityFile = pOpacityF;
}

////////////////////////////////////////////////////////////////////////////////////
std::string menu::getpScaleFile()
{
	return pScaleFile;
}

void menu::setpScaleFile(std::string pScaleF)
{
	pScaleFile = pScaleF;
}

double menu::getpScaleMinConstant()
{
	return pScaleMinConstant;
}

void menu::setpScaleMinConstant(double pScaleMinC)
{
	if (pScaleMinC < 0.01)
	{
		pScaleMinC = 0.01;
		std::cout << "Pixel scalar constant MIN lower than 0.01. Value modified to 0.01." << std::endl;
	}
	if (pScaleMinC > 20)
	{
		pScaleMinC = 20;
		std::cout << "Pixel scalar constant MIN higher than 20. Value modified to 20." << std::endl;
	}

	pScaleMinConstant = pScaleMinC;
}

double menu::getpScaleMaxConstant()
{
	return pScaleMaxConstant;
}

void menu::setpScaleMaxConstant(double pScaleMaxC)
{
	if (pScaleMaxC < 0.01)
	{
		pScaleMaxC = 0.01;
		std::cout << "Pixel scalar constant MAX lower than 0.01. Value modified to 0.01." << std::endl;
	}
	if (pScaleMaxC > 20)
	{
		pScaleMaxC = 20;
		std::cout << "Pixel scalar constant MAX higher than 20. Value modified to 20." << std::endl;
	}

	if (pScaleMaxC < pScaleMinConstant)
	{
		std::cout << "Pixel scalar constant MAX lower than MIN. Values of MIN & MAX switched." << std::endl;
		double temp = pScaleMaxC;
		pScaleMaxC = pScaleMinConstant;
		pScaleMinConstant = temp;
	}

	pScaleMaxConstant = pScaleMaxC;
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMainMenu()
{
	menuItem = ' ';
	std::cout << "A. Define pPath-file" << std::endl;
	std::cout << "B. Define custom object file. (RTG-file)" << std::endl;
	std::cout << "C. Define pColor-file" << std::endl;
	std::cout << "D. Define pOpacity-file" << std::endl;
	std::cout << "E. Define pScale-file" << std::endl;
	std::cout << "F. View attribute files" << std::endl;
	std::cout << "G. View animation" << std::endl;
	std::cout << "X. Exit PPC-viewer" << std::endl;
	std::cout << std::endl;
	std::cout << "Menu item:";
	std::cin >> menuItem;
	std::cin.get();

	switch (menuItem)
	{
		case 'a':
		case 'A':
			showMenuItem1();
			break;

		case 'b':
		case 'B':
			showMenuItem8();
			break;

		case 'c':
		case 'C':
			showMenuItem2();
			break;

		case 'd':
		case 'D':
			showMenuItem7();
			break;

		case 'e':
		case 'E':
			showMenuItem3();
			break;

		case 'f':
		case 'F':
			showMenuItem4();
			break;

		case 'g':
		case 'G':
			showMenuItem5();
			break;

		case 'x':
		case 'X':
			showMenuItem6();
			break;

		default:
			showErrorMessage();
			break;
	}
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem1()
{
	std::cout << "pPath-file:";
	std::cin >> pPathFile;
	std::cout << std::endl;

	showMainMenu();
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem2()
{
	std::cout << "pColor-file:";
	std::cin >> pColorFile;
	std::cout << std::endl;

	showMainMenu();
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem7()
{
	std::cout << "pOpacity-file:";
	std::cin >> pOpacityFile;
	std::cout << std::endl;

	showMainMenu();
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem3()
{
	std::cout << "pScale-file:";
	std::cin >> pScaleFile;
	std::cout << std::endl;

	std::cout << "Pixel scalar MIN:";
	std::cin >> pScaleMinConstant;

	std::cout << "Pixel scalar MAX:";
	std::cin >> pScaleMaxConstant;

	setpScaleMinConstant(pScaleMinConstant);
	setpScaleMaxConstant(pScaleMaxConstant);

	showMainMenu();
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem4()
{
	std::cout << std::endl;
	std::cout <<"----------------------------------------" << std::endl;
	if (pPathFile.size() == 0)
	{
		std::cout << "pPathFile:\t\t" << "Undefined" << std::endl;
	}
	else
	{
		std::cout << "pPathFile:\t\t" << pPathFile << std::endl;
	}

	if (rtgPath.size() == 0)
	{
		std::cout << "RTG-file:\t\t" << "Undefined" << std::endl;
	}
	else
	{
		std::cout << "RTG-file:\t\t" << rtgPath << std::endl;
	}

	if (pColorFile.size() == 0)
	{
		std::cout << "pColorFile:\t\t" << "Undefined" << std::endl;
	}
	else
	{
		std::cout << "pColorFile:\t\t" << pColorFile << std::endl;
	}

	if (pOpacityFile.size() == 0)
	{
		std::cout << "pOpacityFile:\t\t" << "Undefined" << std::endl;
	}
	else
	{
		std::cout << "pOpacityFile:\t\t" << pOpacityFile << std::endl;
	}

	if (pScaleFile.size() == 0)
	{
		std::cout << "pScaleFile:\t\t" << "Undefined" << std::endl;
	}
	else
	{
		std::cout << "pScaleFile:\t\t" << pScaleFile << std::endl;
	}

	std::cout <<"----------------------------------------" << std::endl;
	std::cout << std::endl;
	showMainMenu();
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem5()
{
	std::cout << "Are you sure? (Y / N)" << std::endl;
	std::cout << std::endl;
	std::cout << "Menu item:";
	std::cin >> menuItem;

	switch (menuItem)
	{
		case 'y':
		case 'Y':
			break;

		case 'n':
		case 'N':
			showMainMenu();
			break;

		default:
			showErrorMessage();
			break;
	}
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem6()
{
	std::cout << "Sure you want to quit? (Y / N)" << std::endl;
	std::cout << std::endl;
	std::cout << "Menu item:";
	std::cin >> menuItem;

	switch (menuItem)
	{
		case 'y':
		case 'Y':
			exit(0);
			break;

		case 'n':
		case 'N':
			showMainMenu();
			break;

		default:
			showErrorMessage();
			break;
	}
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showMenuItem8()
{
	std::cout << "RTG-file:";
	std::cin >> rtgPath;
	std::cout << std::endl;
	customObject == true;

	showMainMenu();
}

////////////////////////////////////////////////////////////////////////////////////
void menu::showErrorMessage()
{
	menuItem = ' ';
	std::cout << std::endl;
	std::cout << "Menu-item not defined." << std::endl;
	std::cout << std::endl;
	showMainMenu();
}