#pragma once
#include <iostream>
#include "pixel.h"
#include "ltga.h"

class wrapper
{
public:
	wrapper();
	wrapper(LTGA tga);
	~wrapper();

	inline float getWidth ()	{	return width;	}
	inline float getHeight ()	{	return height;	}
	inline float getDepth ()	{	return depth;	}
	void setDepth(float depth);
	inline unsigned int getPixelDepth ()	{	return pixelDepth;	}

	inline unsigned int getChannels ()	{	return pixelDepth / 8;	}
	inline unsigned int getNumberOfPixels ()	{	return int(width) * int(height);	}
	void setNumberOfPixels(unsigned int nPixels);

	static inline vector getPixelSpacing ()	{	return pixelSpacing;	}
	static inline vector getPixelScalar ()	{	return pixelScalar;	}
	
	inline std::string getPath()	{	return colorMap;	}
	inline void setPath(std::string p)	{	colorMap = p;	}

	static void setPixelSpacing ();
	static void setPixelScalar ();
	bool checkImage();
	void readImageInfo();
	void createPixels();

	void loadImage (LTGA &tga);

	static vector pixelSpacing;
	static vector imageOffset;
	static vector pixelScalar;
	static vector scatterVolumeScalar;
	static vector scatterVolumeDimension;
	pixel *pixels;
	unsigned int numberOfPixels;

private:
	float width;
	float height;
	float depth;
	unsigned int pixelDepth;
	std::string colorMap;
};